# promise timeout rejection

[![NPM version][npm-image]][npm-url]
[![Build status][travis-image]][travis-url]
[![License][license-image]][license-url]
[![Code style][standard-image]][standard-url]

> Reject a promise if it takes more than a set duration.

### Installation

```
$ npm install --save promise-timeout-rejection
```

...or:

```
$ yarn add promise-timeout-rejection
```

### Usage

Wrap a promise and define a timeout in milliseconds. If the promise resolves or rejects in that time then it acts in the exact same way as
the original promise, otherwise it's rejected with a specific `PromiseTimeOutError` error.

__promiseTimeout(promise, timeout)__

```javascript
const promiseTimeout = require('promise-timeout-rejection')
const pausePromise = require('pause-promise')

// `pausePromise` takes an argument of the amount of milliseconds
// it will take to resolve

promiseTimeout(pause(1500), 2000)
  .catch(err => {
    assert(err instanceof promiseTimeout.PromiseTimeOutError)
  })
```

[npm-image]: https://img.shields.io/npm/v/promise-timeout-rejection.svg
[npm-url]: https://npmjs.org/package/promise-timeout-rejection
[travis-image]: https://img.shields.io/travis/roryrjb/promise-timeout-rejection.svg
[travis-url]: https://travis-ci.org/roryrjb/promise-timeout-rejection
[license-image]: http://img.shields.io/npm/l/promise-timeout-rejection.svg
[license-url]: LICENSE
[standard-image]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg
[standard-url]: https://github.com/feross/standard
